%define anolis_release 5
%define _testsdir %{_libexecdir}/lutok/tests

Name: lutok
Version: 0.4
Release: 19.%{anolis_release}%{?dist}
Summary: Lightweight C++ API library for Lua
License: BSD
URL: http://code.google.com/p/lutok/
Source0: https://github.com/jmmv/lutok/releases/download/%{name}-%{version}/%{name}-%{version}.tar.gz
BuildRequires:  gcc-c++ gcc make
BuildRequires: libatf-c++-devel >= 0.20 lua-devel >= 5.2

Requires: lua >= 5.2

%description
Lutok provides thin C++ wrappers around the Lua C API to ease the
interaction between C++ and Lua.  These wrappers make intensive use of
RAII to prevent resource leakage, expose C++-friendly data types, report
errors by means of exceptions and ensure that the Lua stack is always
left untouched in the face of errors.  The library also provides a small
subset of miscellaneous utility functions built on top of the wrappers.

%package devel
Summary: Libraries and header files for %{name} development
Requires: %{name} = %{version}-%{release}
Requires: lua-devel >= 5.1

%description devel
Provides the libraries and header files to develop applications that
use the %{name} C++ API to Lua.

%package tests
Summary: Run-time tests of the Lutok library
Requires: %{name} = %{version}-%{release}
Requires: %{name}-devel = %{version}-%{release}
Requires: libatf-c++ >= 0.20

%description tests
This package installs the run-time tests for the Lutok library.

%package doc
Summary: API documentation of the %{name} library and example programs
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Provides HTML documentation describing the API of the Lutok library
and a collection of sample source programs to demonstrate the use
of the library.

%prep
%autosetup -n %{name}-%{version} -p1

%build
%configure --docdir=%{_defaultdocdir}/%{name}-doc-%{version} \
           --disable-static \
           --htmldir=%{_defaultdocdir}/%{name}-doc-%{version}/html \
           --without-doxygen
# Drop the default RPATH
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
make %{?_smp_mflags} testsdir=%{_testsdir}

%install
make install DESTDIR=%{buildroot} doc_DATA= testsdir=%{_testsdir}
rm %{buildroot}%{_libdir}/lib%{name}.la

%generate_compatibility_deps

%files
%license COPYING
%{_libdir}/lib%{name}.so.3
%{_libdir}/lib%{name}.so.3.0.0
%dir %{abidir}
%{abidir}/lib%{name}.dump

%ldconfig_scriptlets

%files devel
%{_includedir}/%{name}
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/%{name}.pc

%files tests
%{_testsdir}

%files doc
%{_defaultdocdir}/%{name}-doc-%{version}
%doc AUTHORS NEWS README

%changelog
* Tue Dec 26 2023 Xiaoping Liu <lxp01404969@alibaba-inc.com> - 0.4-19.5
- rebuild

* Mon Apr 10 2023 Jing Zhang <renyu.zj@linux.alibaba.com> - 0.4-19.4
- Refact spec

* Tue Mar 28 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.4-19.3
- Del Specific Fields

* Wed Mar 1 2023 Jing Zhang <renyu.zj@linux.alibaba.com> - 0.4-19.2
- Optimize spec

* Wed Mar 9 2022 Zhongling He <zhonglingh@linux.alibaba.com> - 0.4-19.1
- Init for Anolis OS 23
